## gfan 0.6.2

=== Makefile ===
ALL: default

# When -g is used, it seems that stackdump does not work.
# GPROFFLAG = -pg
GPROFFLAG = -g
#GPROFFLAG = 

PREFIX?=/usr/local

BINDIR=$(PREFIX)/bin

RELEASEDIR = gfan0.6.2
MAIN       = gfan

GCATSPATH   = ./


ifeq ($(stackdump),)
STACTDUMP_OPTIONS =
else
STACTDUMP_OPTIONS = -DSTACKDUMP_ENABLED -D__assert_fail=__assert_fail2
endif


ifeq ($(sagepath),)
SAGE_LINKOPTIONS = 
SAGE_INCLUDEOPTIONS =
else
SAGE_LINKOPTIONS = -L$(sagepath)/ -lpython2.6 -lcsage -lsingular
SAGE_INCLUDEOPTIONS = -I $(sagepath)/
SAGE_OBJECTS = sage.o sage_link.so

sage_link.so: sage_link.pyx setup.py
	python setup.py build_ext --inplace --pyrex-include-dirs=$(SAGE_ROOT)/devel/sage/
endif

ifeq ($(gmppath),)
GMP_LINKOPTIONS = -lgmp
GMP_INCLUDEOPTIONS =
else
GMP_LINKOPTIONS = $(gmppath)/lib/libgmp.a
GMP_INCLUDEOPTIONS = -I $(gmppath)/include
endif

ifeq ($(cddnoprefix),)
CDDDEFINE_PREFIX =
else
CDDDEFINE_PREFIX = -DNOCDDPREFIX
endif

ifeq ($(cddpath),)
CDD_LINKOPTIONS = -L/usr/local -lcddgmp
CDD_INCLUDEOPTIONS =
else
CDD_LINKOPTIONS = $(cddpath)/lib/libcddgmp.a
CDD_INCLUDEOPTIONS = -I $(cddpath)/include
endif

ifeq ($(soplex),)
SOPLEX_PATH =
SOPLEX_LINKOPTIONS =
SOPLEX_INCLUDEOPTIONS =
SOPLEX_OBJECTS =
else
SOPLEX_PATH = $(HOME)/math/software/soplex-1.3.2
SOPLEX_LINKOPTIONS = $(SOPLEX_PATH)/lib/libsoplex.linux.x86_64.gnu.opt.a -lz
#SOPLEX_LINKOPTIONS = -lz $(SOPLEX_PATH)/lib/libsoplex.linux.x86.gnu.opt.a
#SOPLEX_LINKOPTIONS = -lz $(SOPLEX_PATH)/lib/libsoplex.darwin.x86.gnu.opt.a
SOPLEX_INCLUDEOPTIONS = -I $(SOPLEX_PATH)/src
SOPLEX_OBJECTS = lp_soplexcdd.o
endif


# rememember to adjust USEFACTORY in field_rationalfunctions2
ifeq ($(singular),)
ifeq ($(factory),)
SINGULAR_PATH =
SINGULAR_LINKOPTIONS =
SINGULAR_INCLUDEOPTIONS =
SINGULAR_OBJECTS = src/polynomialgcd.o 
else
SINGULAR_PATH =
SINGULAR_LINKOPTIONS = -lcf -lcfmem
SINGULAR_INCLUDEOPTIONS = -I /usr/local/include/factory/
SINGULAR_OBJECTS = src/polynomialgcd.o src/ftmpl_inst.o
endif
else
#SINGULAR_PATH = $(HOME)/math/software/Singular-3-1-0
#SINGULAR_LINKOPTIONS =  -L$(SINGULAR_PATH)/Singular -lsingular -lncurses -lreadline
#SINGULAR_INCLUDEOPTIONS = -I $(SINGULAR_PATH)/kernel -I $(SINGULAR_PATH)/omalloc
#SINGULAR_OBJECTS = src/singular.o src/singularconversion.o
SINGULAR_PATH = $(HOME)/math/software/Singular-svn/trunk/x86_64-Linux
SINGULAR_LINKOPTIONS =  -L$(SINGULAR_PATH)/lib -lsingular -lncurses -lreadline  -lcf -lcfmem
SINGULAR_INCLUDEOPTIONS = -I $(SINGULAR_PATH)/include -I $(SINGULAR_PATH)/include/omalloc
SINGULAR_OBJECTS = src/ftmpl_inst.o src/singular.o src/singularconversion.o
#Run the following line before running gfan
#export LD_LIBRARY_PATH="/home/anders/math/software/Singular-svn/trunk/x86_64-Linux/lib/:${LD_LIBRARY_PATH}"
endif

# To produce factory templates:
#g++ -c /home/anders/math/software/factory-3-1-7/ftmpl_inst.cc  -fno-implicit-templates -I /usr/local/include/factory/ -I/home/anders/math/software/factory-3-1-7/ -O2 -fomit-frame-pointer -o ftmpl_inst.o

ADDITIONALLINKOPTIONS = $(CDD_LINKOPTIONS) $(GMP_LINKOPTIONS) $(SOPLEX_LINKOPTIONS) $(SINGULAR_LINKOPTIONS) $(SAGE_LINKOPTIONS) 
ADDITIONALINCLUDEOPTIONS = $(CDD_INCLUDEOPTIONS) $(GMP_INCLUDEOPTIONS) $(SOPLEX_INCLUDEOPTIONS) $(SINGULAR_INCLUDEOPTIONS) $(SAGE_INCLUDEOPTIONS)


MKDIR=mkdir -p

# PREFIX = /usr/local/gcc/6.2.0/bin/
PREFIX =
SHELL       = /bin/sh
#ARCH        = LINUX
CC          = $(PREFIX)gcc
CLINKER     = $(CC)
CXX         = $(PREFIX)g++
CCLINKER    = $(CXX)
#OPTFLAGS    = -O2 -DGMPRATIONAL -DNDEBUG
# Note that gcc produces wrong code with -O3
OPTFLAGS    =  -DGMPRATIONAL -Wuninitialized -fno-omit-frame-pointer -O2	 #-O3 -fno-guess-branch-probability #-DNDEBUG
#OPTFLAGS    =  -DGMPRATIONAL -Wuninitialized -fno-omit-frame-pointer -O3 -mavx -msse2  -finline-limit=1000 -ffast-math -Wuninitialized # -fno-guess-branch-probability #-DNDEBUG -ftree-vectorizer-verbose=2
#OPTFLAGS    =  -DGMPRATIONAL -Wuninitialized -fno-omit-frame-pointer -O1             -fno-guess-branch-probability
 #-DNDEBUG
#OPTFLAGS    =  -DGMPRATIONAL -Wuninitialized -fno-omit-frame-pointer -O3 -mavx -msse2 -ftree-vectorizer-verbose=2 -finline-limit=1000 -ffast-math #-DNDEBUG
#OPTFLAGS    =  -DGMPRATIONAL -Wuninitialized -fno-omit-frame-pointer -O3 -mavx -msse2 -ftree-vectorizer-verbose=2 -march=native -unroll-loops --param max-unroll-times=4 -ffast-math #-DNDEBUG
#OPTFLAGS    =  -DGMPRATIONAL -Wuninitialized -fno-omit-frame-pointer -O3 -msse2 -ftree-vectorizer-verbose=2 -ffast-math #-DNDEBUG
#OPTFLAGS    =  -DGMPRATIONAL -Wuninitialized -fno-omit-frame-pointer -O3 -mavx -msse2 -ftree-vectorizer-verbose=2 -ffast-math #-DNDEBUG

CFLAGS	  = $(OPTFLAGS) $(GPROFFLAG) $(STACTDUMP_OPTIONS) $(ADDITIONALINCLUDEOPTIONS) -std=c++0x -g $(CDDDEFINE_PREFIX) #-pedantic
#CFLAGS	  = $(OPTFLAGS) $(GPROFFLAG) $(STACTDUMP_OPTIONS) $(ADDITIONALINCLUDEOPTIONS) -D_GLIBCXX_DEBUG -std=c++0x -g $(CDDDEFINE_PREFIX) #-pedantic
CCFLAGS	  = $(CFLAGS)
FFLAGS	  = $(OPTFLAGS)

CATSOBJECTS =	lp_cdd.o \
		parser.o \
		field.o \
		monomial.o \
		printer.o	\
		polynomial.o \
		termorder.o \
		term.o \
		vektor.o \
		division.o \
		buchberger.o \
		wallideal.o \
		lp.o \
		enumeration.o \
		ep_standard.o \
		ep_xfig.o \
		reversesearch.o \
		application.o \
		timer.o \
		renderer.o \
		field_rationals.o \
		symmetry.o \
		breadthfirstsearch.o \
		genericwalk.o \
		minkowskisum.o \
		newtonpolytope.o \
		tropical.o \
		dimension.o \
		bergman.o \
		subspace.o \
		polyhedralcone.o \
		gfanapplication.o \
		polyhedralfan.o \
		tropical2.o \
		field_zmodpz.o \
		binomial.o \
		matrix.o \
		latticeideal.o \
		scarf.o \
		xfig.o \
		halfopencone.o \
		lll.o \
		multiplicity.o \
		substitute.o \
		polymakefile.o \
		saturation.o \
		determinant.o \
		polynomialring.o \
		log.o \
		tropicalbasis.o \
		symmetriccomplex.o \
		linalg.o \
		minors.o \
		continuedfractions.o \
		triangulation.o \
		minkowskidual.o \
		regularsubdivision.o \
		fieldlp.o \
		field_rationalfunctions.o \
		tropical_weildivisor.o \
		intsinpolytope.o\
		lattice.o \
		graph.o \
		restrictedautoreduction.o \
		tropicaltraverse.o \
		groebnerengine.o \
		ge_gfan.o \
		nbody.o \
		codimoneconnectedness.o \
		tropicalmap.o \
		traverser_tropical.o \
		traverser_groebnerfan.o \
		field_rationalfunctions2.o \
	mixedvolume.o \
	traverser_stableintersection.o \
	traverser_secondaryfan.o \
	linalgfloat.o \
	primarydecomposition.o \
	tropicaldeterminant.o \
	determinantpoly.o \
	traverser_sphere.o \
	gfanlib_zcone.o \
	gfanlib_symmetry.o \
	gfanlib_symmetriccomplex.o \
	gfanlib_polyhedralfan.o \
	gfanlib_zfan.o \
	gfanlib_polymakefile.o \
	gfanlib_mixedvolume.o \
	gfanlib_circuittableint.o \
	gfanlib_paralleltraverser.o \
	padic.o \
	integergb.o \
	traverser_resultantfan.o \
	bsptree.o \
	traverser_resultantfanspecialization.o \
	myassert.o \
	traverser_bsptree.o \
	gfanlib_traversal.o \
	tropicalcurve.o \
	packedmonomial.o \
	gmpallocator.o \
#		symmetrictraversal.o \
	#	restrictedgfan.o \

APPDELETEOBJECTS = 		app_add.o \
		app_berndssuggestion.o \
		app_grassmanndata2.o \
		app_grassmanndata3.o \
		app_construction.o \
		app_checkridges.o \
		app_edwinsconjecture.o \
		app_fvector.o \
		app_grassmanndata.o \
		app_groupfacetbinomials.o \
		app_istriangulation.o \
		app_latticetest.o \
		app_markpolynomialset.o \
		app_moeckel.o \
		app_polytopetopolynomial.o \
		app_rendernewtonpolytope.o \
		app_tropical.o \
		app_xfigconstruction.o \
		app_liststandardmonomials.o \
#		app_isrefinement.o \    # needs to be fixed so that it compiles with gcc version 2.96 (legolas.imf.au.dk)


APPOBJECTS = app_main.o \
		app_buchberger.o \
		app_doesidealcontain.o \
		app_facets.o \
		app_groebnercone.o \
		app_homogeneityspace.o \
		app_homogenize.o \
		app_initialforms.o \
		app_interactive.o \
		app_isgroebnerbasis.o \
		app_ismarkedgroebnerbasis.o \
		app_krulldimension.o \
		app_leadingterms.o \
		app_multiplymatrix.o \
		app_polynomialsetunion.o \
		app_render.o \
		app_renderstaircase.o \
		app_stats.o \
		app_substitute.o \
		app_supportindices.o \
		app_tolatex.o \
		app_transposematrix.o \
		app_tropicalbasis.o \
		app_tropicalintersection.o \
		app_tropicalstartingcone.o \
		app_tropicaltraverse.o \
		app_walk.o \
		app_weightvector.o \
		app_scarfisgeneric.o \
		app_scarfvisualize.o \
		app_scarfcomplex.o \
		app_sturmsequence.o \
		app_latticeideal.o \
		app_lll.o \
		app_tropicalmultiplicity.o \
		app_idealintersection.o \
		app_test.o \
		app_saturation.o \
		app_idealproduct.o \
		app_representatives.o \
		app_tropicallifting.o \
		app_topolyhedralfan.o \
		app_tropicalbruteforce.o \
		app_secondaryfan.o \
		app_composepermutations.o \
		app_minors.o \
		app_tropicalrank.o \
		app_minkowski.o \
		app_triangulate.o \
		app_tropicallinearspace.o \
		app_combinerays.o \
		app_regularsubdivision.o \
		app_lpsolve.o \
		app_tropicalweildivisor.o \
		app_lattice.o \
		app_intsinpolytope.o\
		app_tropicalevaluation.o \
		app_smalessixth.o \
		app_smalessixth2.o \
		app_nbody.o \
		app_spolynomial.o \
		app_link.o \
		app_normalfancleanup.o \
		app_tropicalfunction.o \
		app_volume.o \
		app_isconnected.o \
		app_tropicalhypersurface.o \
		app_product.o \
		app_commonrefinement.o \
		app_tropicalimage.o \
		app_groebnerfan.o \
		app_fanhomology.o \
		app_genericlinearchange.o \
		app_mixedvolume.o \
		app_fiberpolytope.o \
		app_symmetries.o \
		app_evaluate.o \
		app_exponentlattice.o \
		app_minimalassociatedprimes.o \
		app_realroots.o \
		app_initialdeterminant.o \
		app_fansubfan.o \
		app_fancones.o \
		app_issmooth.o \
		app_fancoarsening.o \
		app_pointconfiguration.o \
		app_librarytest.o \
		app_padic.o \
		app_integergb.o \
		app_matrixproduct.o \
		app_traversetropicalintersection.o \
		app_markpolynomialset.o \
		app_tropicalhypersurfacereconstruction.o \
		app_resultantfan.o \
		app_isbalanced.o \
		app_polytopealgebra.o \
		app_debug.o \
		app_randompolynomials.o \
		app_tropicalcurve.o \
		app_tropicalhomotopy.o \
		app_integerfactorization.o \
		app_tropicalvarietyspan.o \
		app_chowbetti.o \
		

GFANLIBFILES= 	gfanlib.h \
				gfanlib_polyhedralfan.cpp \
				gfanlib_q.h \
				gfanlib_symmetry.h \
				gfanlib_zcone.cpp \
				gfanlib_z.h \
				gfanlib_matrix.h \
				gfanlib_polyhedralfan.h \
				gfanlib_symmetriccomplex.cpp \
				gfanlib_zcone.h \
				gfanlib_polymakefile.cpp \
				gfanlib_symmetriccomplex.h \
				gfanlib_zfan.cpp \
				gfanlib_polymakefile.h \
				gfanlib_symmetry.cpp \
				gfanlib_vector.h \
				gfanlib_zfan.h \
				gfanlib_circuittableint.h \
				gfanlib_circuittableint.cpp \
				gfanlib_mixedvolume.h \
				gfanlib_mixedvolume.cpp \
				gfanlib_paralleltraverser.h \
				gfanlib_paralleltraverser.cpp \
				gfanlib_tropicalhomotopy.h \
	#			gfanlib_tableau.h \   we do not yet support this one


EXECS	  = $(MAIN)

# When compiling symmetrictraversal.cpp as any other file, it causes the program to crash in certain situations.
# (compiling with gcc version 4.7.2 and running gfan _tropicaltraverse on a starting cone for Grassmann3_7)
# Either this is a bug in the code or in the compiler. The bug disappears by compiling with -fno-guess-branch-probability
src/symmetrictraversal.o: src/symmetrictraversal.cpp
	$(CXX) $(CFLAGS) -fno-guess-branch-probability  -c src/symmetrictraversal.cpp -o src/symmetrictraversal.o
# If compiling with clang, use the line below instead:
#	$(CXX) $(CFLAGS) -c src/symmetrictraversal.cpp -o src/symmetrictraversal.o

# Define suffixes to make the program compile on legolas.imf.au.dk :
.SUFFIXES: .o .cpp .c

OBJECTS = 	$(addprefix src/,$(SOPLEX_OBJECTS)) \
		$(SINGULAR_OBJECTS) \
		$(SAGE_OBJECTS) \
		$(addprefix src/,$(CATSOBJECTS)) \
		$(addprefix src/,$(APPOBJECTS)) \
		src/symmetrictraversal.o

all: $(MAIN)

$(BINDIR): $(PREFIX)
	$(MKDIR) $(BINDIR)

$(PREFIX):
	$(MKDIR) $(PREFIX)

default: $(OBJECTS) $(ADDITIONALOBJECTS) $(EXECS)

$(MAIN): $(OBJECTS)
#	$(CCLINKER) $(OBJECTS) $(ADDITIONALLINKOPTIONS) $(GPROFFLAG) -lpthread  -o $(MAIN)

=== doc/Makefile ===
all:
	latex manual.tex
	bibtex manual
	dvips manual.dvi -omanual.ps
	dvipdf manual.dvi manual.pdf

=== homepage/Makefile ===
upload:
	mkdir -p uploaddir
	cp gfan.html uploaddir/
	cp binaries.html uploaddir/
	cp *.png uploaddir/
	cp ../gfan0.6.tar.gz uploaddir/
	cp ../gfanlib0.6.2.tar.gz uploaddir/
	cp presentation/presentation.ps uploaddir/
	cp presentation/presentation.pdf uploaddir/
	cp ../doc/manual.ps uploaddir/gfanmanual0.6.ps
	cp ../doc/manual.pdf uploaddir/gfanmanual0.6.pdf
	scp uploaddir/* jensen@elrond.math.au.dk:public_html/software/gfan/
#	scp uploaddir/* jensen@orc06.imf.au.dk:public_html/software/gfan/
#	scp uploaddir/* jensen@heawood.math.tu-berlin.de:WWW/software/gfan/
#	scp uploaddir/* jensen@horner:WWW/software/gfan/
#	scp uploaddir/* ajensen@imf.au.dk:public_html/software/gfan/

=== homepage/presentation/Makefile ===
all:
	latex presentation.tex
	dvips presentation.dvi -opresentation.ps
	dvipdf presentation.dvi presentation.pdf

=== debian/changelog ===
gfan (0.6.2-6) unstable; urgency=medium

  * debian/patches/find-name.patch
    - Add Forwarded field.
  * debian/patches/remove_failing_tests_on_32bits.patch
    - Remove patch; no longer needed.
  * debian/rules
    - Add -ffloat-store to CFLAGS on 32-bit architectures; fixes
      0009RenderStairCase test.
    - Convert override_* to execute_before_* where possible.
    - Build documentation a second time to fix references.

 -- Doug Torrance <dtorrance@piedmont.edu>  Sun, 21 Nov 2021 23:51:26 -0500

gfan (0.6.2-5) unstable; urgency=medium

  [ Andreas Tille ]
  * Fix spelling
  * Set field Upstream-Contact in debian/copyright.
  * Remove obsolete fields Contact, Name from debian/upstream/metadata
    (already present in machine-readable debian/copyright).

  [ Doug Torrance ]
  * debian/control
    - Update Maintainer to Debian Math Team.
    - Update Vcs-* fields (science-team -> math-team).
    - Bump Standards-Version to 4.6.0.
  * debian/copyright
    - Add myself to copyright holders for debian/*.
  * debian/patches/find-name.patch
    - Properly terminate while loop when finding application name.
  * debian/rules
    - Stop including architecture.mk; not used.
    - Move code for generating manpage to one place.
    - Stop setting DH_VERBOSE.

 -- Doug Torrance <dtorrance@piedmont.edu>  Mon, 08 Nov 2021 19:33:55 -0500

gfan (0.6.2-4) unstable; urgency=medium

  * debian/control
    - Drop versioned dependency on libcdd-dev; the minimum version was
      094g, but that is in oldoldstable.
  * debian/patches/remove_failing_tests_on_32.bits.patch
    - Restore patch; we will return to just skipping this test, as we
      can't predict the expected output based on 32-bit v. 64-bit
      architecture alone.
  * debian/patches/render-staircase.patch
    - Remove patch.
  * debian/rules
    - Stop patching the 0009RenderStairCase test on 32-bit architectures.
    - Refactor override_dh_link target.  Previously, we called dh_link
      once for each app to create a symlink for the manpage.  However,
      each individual call was recreating the symlinks to the apps
      themselves, resulting in nearly 9000 calls to rm and ln!  We
      reduce this down to a single call to dh_link, removing all of the
      redundancies.

 -- Doug Torrance <dtorrance@piedmont.edu>  Thu, 03 Dec 2020 20:20:45 -0500

gfan (0.6.2-3) unstable; urgency=medium

  * debian/clean
    - Remove generated manpage during dh_clean.
  * debian/compat
    - Remove file; we now set the compatibility level with
      debhelper-compat.
  * debian/control
    - Bump Standards-Version to 4.5.1.
    - Add Rules-Requires-Root field.
    - Update Homepage.
    - Bump to debhelper compatibility level 13.
  * debian/copyright
    - Update Source.
  * debian/gfan.1.in
    - Rename file; the manpage is now generated during build.
    - Use special characters for umlauts to avoid troff warnings.
  * debian/gfan.install
    - New file; install testsuite.
  * debian/patches
    - Add Forwarded tags where needed.
  * debian/patches/64_bit_int.patch
    - Use int64_t instead of long for 64-bit integers; the overflow
      on 32-bit systems was causing an infinite loop in a test
      (Closes: #974558).
  * debian/patches/dont_forget_flags_debian.patch
    - Don't forget CPPFLAGS for symmetrictraversal.cpp.
  * debian/patches/{fix_spelling_errors,make_tests_return_error}.patch
    - Don't reintroduce a typo in a later patch.
  * debian/patches/no_manual_date.patch
    - Remove patch; no longer necessary since LaTeX supports
      SOURCE_DATE_EPOCH.
  * debian/patches/render-staircase.patch
    - New patch; fix failing test on 32-bit architectures.
  * debian/rules
    - Remove 0602ResultantFanProjection from tests to skip on 32-bit
      architectures; the underlying problem has been fixed and it no
      longer fails.
    - New override_dh_installman target; generate manpage during
      build using the source date and version number.
    - Export FORCE_SOURCE_DATE so LaTeX uses SOURCE_DATE_EPOCH and we
      get a reproducible build of the manual.
    - Add override_dh_install target; don't install temporary files
      from testsuite directory.
    - Instead of skipping a failing test on 32-bit architectures, we
      now apply a patch to fix it.
  * debian/salsa-ci.yml
    - Add Salsa pipelines config file.
  * debian/tests/control
    - Use installed testsuite directory.
  * debian/watch
    - Update url.

 -- Doug Torrance <dtorrance@piedmont.edu>  Sat, 21 Nov 2020 22:00:45 -0500

gfan (0.6.2-2) unstable; urgency=medium

  * debian/patches/no_manual_date.patch
    - Use empty date in manual for reproducible builds.
  * debian/tests/control
    - Specify executable to use for tests.  Otherwise the default
      (./gfan) is used, which only works during build and not during
      DEP-8 tests.

 -- Doug Torrance <dtorrance@piedmont.edu>  Mon, 24 Sep 2018 07:44:07 -0400

gfan (0.6.2-1) unstable; urgency=medium

  * Upload to unstable.
  * debian/control
    - Bump Standards-Version to 4.2.1.

 -- Doug Torrance <dtorrance@piedmont.edu>  Wed, 05 Sep 2018 16:11:52 -0400

gfan (0.6.2-1~exp2) experimental; urgency=medium

  * debian/control
    - Bump Standards-Version to 4.2.0.
  * debian/patches/remove_failing_tests_on_32bits.patch
    - Remove patch.
  * debian/rules
    - Remove tests which fail on 32-bit architectures.  Previously, we removed
      0009RenderStairCase on *all* architectures using quilt.  We now use
      dpkg-architecture to only remove this and the newly-introduced
      0602ResultantFanProjection on the architectures on which they fail
      (Closes: #905300).

 -- Doug Torrance <dtorrance@piedmont.edu>  Wed, 22 Aug 2018 14:37:22 -0400

gfan (0.6.2-1~exp1) experimental; urgency=medium

  [ Andreas Tille ]
  * Homepage is not part of UpstreamMetadata any more since it is redundant

  [ Doug Torrance ]
  * New upstream release.
    - Manual is now no longer released under a non-DFSG license.
  * debian/clean


=== debian/control ===
Source: gfan
Section: math
Priority: optional
Maintainer: Debian Math Team <team+math@tracker.debian.org>
Uploaders: Tim Abbott <tabbott@mit.edu>,
           Cédric Boutillier <boutil@debian.org>,
           Doug Torrance <dtorrance@piedmont.edu>
Homepage: https://users-math.au.dk/jensen/software/gfan/gfan.html
Vcs-Browser: https://salsa.debian.org/math-team/gfan
Vcs-Git: https://salsa.debian.org/math-team/gfan.git
Build-Depends: debhelper-compat (= 13),
               ghostscript,
               html2text,
               libcdd-dev,
               libgmp-dev,
               texlive-latex-base,
               texlive-latex-recommended,
               texlive-plain-generic
Standards-Version: 4.6.0
Rules-Requires-Root: no

Package: gfan
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: program for computing with Groebner fans
 Gfan is a software package for computing Groebner fans and tropical
 varieties. These are polyhedral fans associated to polynomial
 ideals. The maximal cones of a Groebner fan are in bijection with
 the marked reduced Groebner bases of its defining ideal. The
 software computes all marked reduced Groebner bases of an ideal.
 Their union is a universal Groebner basis. The tropical variety of a
 polynomial ideal is a certain subcomplex of the Groebner fan. Gfan
 contains algorithms for computing this complex for general ideals and
 specialized algorithms for tropical curves, tropical hypersurfaces
 and tropical varieties of prime ideals. In addition to the above core
 functions the package contains many tools which are useful in the
 study of Groebner bases, initial ideals and tropical geometry. Among
 these are an interactive traversal program for Groebner fans and
 programs for graphical renderings.
 .
 For ordinary Groebner basis computations Gfan is not competitive in
 speed compared to programs such as CoCoA, Singular and Macaulay2.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# for reproducible manual
export FORCE_SOURCE_DATE = 1

# fix 0009RenderStairCase test on 32-bit architectures
include /usr/share/dpkg/architecture.mk
ifeq ($(DEB_HOST_ARCH_BITS), 32)
export DEB_CFLAGS_MAINT_APPEND = -ffloat-store
endif

DEB_DESTDIR=./debian/gfan

%:
	dh $@

override_dh_auto_install:
	$(MAKE) install PREFIX=$(DEB_DESTDIR)/usr

override_dh_clean:
	dh_clean -X~

GFAN_APPS = $(shell $(DEB_DESTDIR)/usr/bin/gfan_list | grep "^gfan")
MAN1DIR = usr/share/man/man1
GFAN_LINKS = $(patsubst %, $(MAN1DIR)/gfan.1 $(MAN1DIR)/%.1, $(GFAN_APPS))
override_dh_link:
	dh_link $(GFAN_LINKS)

override_dh_install:
	dh_install -X~

override_dh_installchangelogs:
	html2text homepage/gfan.html | \
		sed -n '/\*\+ Download \*\+/,/\*\+ Gfanlib \*\+/{//!p}' > \
		ChangeLog
	dh_installchangelogs
	rm ChangeLog

execute_before_dh_installdocs:
	$(MAKE) -C doc
	$(MAKE) -C doc # run again to fix references

execute_before_dh_installman: debian/gfan.1

# for DEB_VERSION_UPSTREAM
include /usr/share/dpkg/pkg-info.mk

DATE := $(shell LC_ALL=C date +'%B %Y' -d @$(SOURCE_DATE_EPOCH))

debian/gfan.1: debian/gfan.1.in
	sed -e "s/@DATE@/$(DATE)/" \
		-e "s/@VERSION@/$(DEB_VERSION_UPSTREAM)/" $< > $@

=== debian/tests/control ===
Test-Command: cp -r /usr/share/gfan/testsuite $AUTOPKGTEST_TMP &&
 gfan _test --gfan /usr/bin/gfan --suite $AUTOPKGTEST_TMP/testsuite
Depends: gfan
Restrictions: allow-stderr

## gfan 0.7

=== Makefile ===
--- 
+++ 
@@ -9,7 +9,7 @@
 
 BINDIR=$(PREFIX)/bin
 
-RELEASEDIR = gfan0.6.2
+RELEASEDIR = gfan0.7
 MAIN       = gfan
 
 GCATSPATH   = ./
@@ -70,6 +70,11 @@
 SOPLEX_OBJECTS = lp_soplexcdd.o
 endif
 
+ifeq ($(vectorize),)
+VECTORISE =
+else
+VECTORISE = -mavx -msse2
+endif
 
 # rememember to adjust USEFACTORY in field_rationalfunctions2
 ifeq ($(singular),)
@@ -107,16 +112,25 @@
 MKDIR=mkdir -p
 
 # PREFIX = /usr/local/gcc/6.2.0/bin/
+# PREFIX = /usr/local/gcc-8.1/bin/
 PREFIX =
 SHELL       = /bin/sh
 #ARCH        = LINUX
+
 CC          = $(PREFIX)gcc
 CLINKER     = $(CC)
 CXX         = $(PREFIX)g++
 CCLINKER    = $(CXX)
+
+#CC          = $(PREFIX)gcc-8.1
+#CLINKER     = $(CC)
+#CXX         = $(PREFIX)g++-8.1
+#CCLINKER    = $(CXX)
+
 #OPTFLAGS    = -O2 -DGMPRATIONAL -DNDEBUG
 # Note that gcc produces wrong code with -O3
-OPTFLAGS    =  -DGMPRATIONAL -Wuninitialized -fno-omit-frame-pointer -O2	 #-O3 -fno-guess-branch-probability #-DNDEBUG
+# OPTFLAGS    =  -DGMPRATIONAL -Wuninitialized -O3 -fno-omit-frame-pointer -fdelete-null-pointer-checks -fno-inline-functions -fno-inline-small-functions#-fno-common  #-fno-inline-functions #-D_GLIBCXX_DEBUG #-O2	 #-O3 -fno-guess-branch-probability #-DNDEBUG
+OPTFLAGS    =  -DGMPRATIONAL -Wuninitialized -O3  $(VECTORISE)  -finline-limit=1000 -ffast-math -fno-omit-frame-pointer -fno-inline-functions -fdelete-null-pointer-checks #-D_GLIBCXX_DEBUG #-fno-inline-functions -fno-inline-small-functions#-fno-common  #-fno-inline-functions #-D_GLIBCXX_DEBUG #-O2	 #-O3 -fno-guess-branch-probability #-DNDEBUG
 #OPTFLAGS    =  -DGMPRATIONAL -Wuninitialized -fno-omit-frame-pointer -O3 -mavx -msse2  -finline-limit=1000 -ffast-math -Wuninitialized # -fno-guess-branch-probability #-DNDEBUG -ftree-vectorizer-verbose=2
 #OPTFLAGS    =  -DGMPRATIONAL -Wuninitialized -fno-omit-frame-pointer -O1             -fno-guess-branch-probability
  #-DNDEBUG
@@ -125,8 +139,9 @@
 #OPTFLAGS    =  -DGMPRATIONAL -Wuninitialized -fno-omit-frame-pointer -O3 -msse2 -ftree-vectorizer-verbose=2 -ffast-math #-DNDEBUG
 #OPTFLAGS    =  -DGMPRATIONAL -Wuninitialized -fno-omit-frame-pointer -O3 -mavx -msse2 -ftree-vectorizer-verbose=2 -ffast-math #-DNDEBUG
 
-CFLAGS	  = $(OPTFLAGS) $(GPROFFLAG) $(STACTDUMP_OPTIONS) $(ADDITIONALINCLUDEOPTIONS) -std=c++0x -g $(CDDDEFINE_PREFIX) #-pedantic
-#CFLAGS	  = $(OPTFLAGS) $(GPROFFLAG) $(STACTDUMP_OPTIONS) $(ADDITIONALINCLUDEOPTIONS) -D_GLIBCXX_DEBUG -std=c++0x -g $(CDDDEFINE_PREFIX) #-pedantic
+CFLAGS	  = $(OPTFLAGS) $(GPROFFLAG) $(STACTDUMP_OPTIONS) $(ADDITIONALINCLUDEOPTIONS) -g $(CDDDEFINE_PREFIX) -std=c++2a #-pedantic
+#CFLAGS	  = $(OPTFLAGS) $(GPROFFLAG) $(STACTDUMP_OPTIONS) $(ADDITIONALINCLUDEOPTIONS) -std=c++0x -g $(CDDDEFINE_PREFIX) #-pedantic
+#CFLAGS	  = $(OPTFLAGS) $(GPROFFLAG) $(STACTDUMP_OPTIONS) $(ADDITIONALINCLUDEOPTIONS) -D_GLIBCXX_DEBUG -g $(CDDDEFINE_PREFIX) #-pedantic
 CCFLAGS	  = $(CFLAGS)
 FFLAGS	  = $(OPTFLAGS)
 
@@ -231,6 +246,11 @@
 	tropicalcurve.o \
 	packedmonomial.o \
 	gmpallocator.o \
+	gfanlib_memoryresource.o \
+	gfanlib_hypersurfaceintersection.o \
+	divisionobject.o \
+	gfanlibglue.o \
+#	gfanlib_circuittableinteger.o \
 #		symmetrictraversal.o \
 	#	restrictedgfan.o \
 
@@ -359,7 +379,11 @@
 		app_integerfactorization.o \
 		app_tropicalvarietyspan.o \
 		app_chowbetti.o \
-		
+		app_anton.o \
+		app_components.o \
+		app_tropicalprevarietycomponents.o \
+		app_tropicalprevariety.o \
+		app_anders.o \
 
 GFANLIBFILES= 	gfanlib.h \
 				gfanlib_polyhedralfan.cpp \
@@ -385,38 +409,11 @@
 				gfanlib_paralleltraverser.h \
 				gfanlib_paralleltraverser.cpp \
 				gfanlib_tropicalhomotopy.h \
+				gfanlib_memoryresource.h \
+				gfanlib_memoryresource.cpp \
 	#			gfanlib_tableau.h \   we do not yet support this one
 
 
 EXECS	  = $(MAIN)
 
 # When compiling symmetrictraversal.cpp as any other file, it causes the program to crash in certain situations.
-# (compiling with gcc version 4.7.2 and running gfan _tropicaltraverse on a starting cone for Grassmann3_7)
-# Either this is a bug in the code or in the compiler. The bug disappears by compiling with -fno-guess-branch-probability
-src/symmetrictraversal.o: src/symmetrictraversal.cpp
-	$(CXX) $(CFLAGS) -fno-guess-branch-probability  -c src/symmetrictraversal.cpp -o src/symmetrictraversal.o
-# If compiling with clang, use the line below instead:
-#	$(CXX) $(CFLAGS) -c src/symmetrictraversal.cpp -o src/symmetrictraversal.o
-
-# Define suffixes to make the program compile on legolas.imf.au.dk :
-.SUFFIXES: .o .cpp .c
-
-OBJECTS = 	$(addprefix src/,$(SOPLEX_OBJECTS)) \
-		$(SINGULAR_OBJECTS) \
-		$(SAGE_OBJECTS) \
-		$(addprefix src/,$(CATSOBJECTS)) \
-		$(addprefix src/,$(APPOBJECTS)) \
-		src/symmetrictraversal.o
-
-all: $(MAIN)
-
-$(BINDIR): $(PREFIX)
-	$(MKDIR) $(BINDIR)
-
-$(PREFIX):
-	$(MKDIR) $(PREFIX)
-
-default: $(OBJECTS) $(ADDITIONALOBJECTS) $(EXECS)
-
-$(MAIN): $(OBJECTS)
-#	$(CCLINKER) $(OBJECTS) $(ADDITIONALLINKOPTIONS) $(GPROFFLAG) -lpthread  -o $(MAIN)

=== homepage/Makefile ===
upload:
	mkdir -p uploaddir
	cp gfan.html uploaddir/
	cp binaries.html uploaddir/
	cp *.png uploaddir/
	cp ../gfan0.7.tar.gz uploaddir/
#	cp ../gfan0.6.tar.gz uploaddir/
#	cp ../gfanlib0.6.2.tar.gz uploaddir/
	cp presentation/presentation.ps uploaddir/
	cp presentation/presentation.pdf uploaddir/
	cp ../doc/manual.ps uploaddir/gfanmanual0.7.ps
	cp ../doc/manual.pdf uploaddir/gfanmanual0.7.pdf
	scp uploaddir/* au27818@tildefiles.au.dk:public_html/software/gfan/
#	scp uploaddir/* jensen@elrond.math.au.dk:public_html/software/gfan/
#	scp uploaddir/* jensen@orc06.imf.au.dk:public_html/software/gfan/
#	scp uploaddir/* jensen@heawood.math.tu-berlin.de:WWW/software/gfan/
#	scp uploaddir/* jensen@horner:WWW/software/gfan/
#	scp uploaddir/* ajensen@imf.au.dk:public_html/software/gfan/

=== debian/changelog ===
gfan (0.7-3) unstable; urgency=medium

  * debian/control
    - Bump Standards-Version to 4.7.2
  * debian/copyright
    - Update my copyright years
  * debian/patches/skip-mixed-volume-test.patch
    - Skip test that fails on armel.

 -- Doug Torrance <dtorrance@debian.org>  Fri, 02 May 2025 07:08:50 -0400

gfan (0.7-2) unstable; urgency=medium

  * debian/patches/int128.patch
    - New patch; use Abseil to provide 128-bit integers on 32-bit
      architectures that don't support them natively.
  * debian/control
    - Add libabsl-dev to Build-Depends; needed for new 128-bit integer
      patch.

 -- Doug Torrance <dtorrance@debian.org>  Thu, 24 Oct 2024 11:25:53 -0400

gfan (0.7-1) unstable; urgency=medium

  * New upstream release.
  * debian/control
    - Bump Standards-Version to 4.7.0.
  * debian/patches
    - Refresh for new upstream release.
    - Remove set_locale_test_0008.patch, 64_bit_int.patch, and
      find-name.patch; applied upstream.
  * debian/patches/cstdint.patch
    - New patch; include <cstdint> for std::int64_t.
  * debian/patches/dont_forget_flags_debian.patch
    - Move a couple essential flags from now-unused OPTFLAGS to CPPFLAGS.
  * debian/watch
    - Add uversionmangle option to prepend ~ before beta, etc.

 -- Doug Torrance <dtorrance@debian.org>  Thu, 22 Aug 2024 06:54:03 -0400

gfan (0.6.2-7) unstable; urgency=medium

  * debian/control
    - Bump Standards-Version to 4.6.2.
    - Update my email address (now a Debian developer).
  * debian/copyright
    - Update my copyright years and email address.
  * debian/patches/*
    - Update my email address.
  * debian/patches/remove_failing_tests_on_32bits.patch
    - Restore patch.
  * debian/rules
    - Stop adding -ffloat-store flag; not working with GCC 13.
  * debian/source/lintian-overrides
    - New file; override false positive source-is-missing error.

 -- Doug Torrance <dtorrance@debian.org>  Sat, 23 Mar 2024 23:35:04 -0400

=== debian/control ===
--- 
+++ 
@@ -4,19 +4,20 @@
 Maintainer: Debian Math Team <team+math@tracker.debian.org>
 Uploaders: Tim Abbott <tabbott@mit.edu>,
            Cédric Boutillier <boutil@debian.org>,
-           Doug Torrance <dtorrance@piedmont.edu>
+           Doug Torrance <dtorrance@debian.org>
 Homepage: https://users-math.au.dk/jensen/software/gfan/gfan.html
 Vcs-Browser: https://salsa.debian.org/math-team/gfan
 Vcs-Git: https://salsa.debian.org/math-team/gfan.git
 Build-Depends: debhelper-compat (= 13),
                ghostscript,
                html2text,
+               libabsl-dev,
                libcdd-dev,
                libgmp-dev,
                texlive-latex-base,
                texlive-latex-recommended,
                texlive-plain-generic
-Standards-Version: 4.6.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 
 Package: gfan

=== debian/watch ===
version=4
opts=uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/ \
https://users-math.au.dk/jensen/software/gfan/gfan.html \
@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@
